dnl -*- shell-script -*-
dnl
dnl Copyright (c) 2002-2003 Indiana University.  All rights reserved.
dnl Copyright (c) 1996, 1997, 1998, 2000 University of Notre Dame.
dnl                         All rights reserved.
dnl 
dnl This file is part of the OOMPI software package.  For license
dnl information, see the LICENSE file in the top level directory of the
dnl OOMPI source distribution.
dnl
dnl $Id: acinclude.m4,v 1.5 2003/02/13 21:07:45 jsquyres Exp $
dnl

#############################################################################

# Get all the respective tests; these are from the LSC standard m4
# repository

sinclude(config/os_check_signal_type.m4)
sinclude(config/cxx_find_exception_flags.m4)
sinclude(config/cxx_have_exceptions.m4)
sinclude(config/cxx_find_template_repository.m4)
sinclude(config/cxx_check_type.m4)
sinclude(config/mpi_check_err_pending.m4)
sinclude(config/mpi_check_mpi_h.m4)
sinclude(config/mpi_check_link.m4)

#############################################################################

# This test is not standardized enough to put in the LSC standard m4
# tests repository

define([LSC_MPI_CHECK_CONSTANTS_TYPE],[
#
# Check whether MPI constants are actual MPI handles or integer constants
#

AC_MSG_CHECKING([for type of MPI constants])
AC_TRY_COMPILE([#include <mpi.h>],[MPI_Comm *foo = &MPI_COMM_NULL;], 
    LSC_MPI_CONSTANTS_ARE_HANDLES="1", LSC_MPI_CONSTANTS_ARE_HANDLES="0")
if test "$LSC_MPI_CONSTANTS_ARE_HANDLES" = "1"; then
    AC_MSG_RESULT([handles])
else
    AC_MSG_RESULT([constants])
fi])dnl

#############################################################################

# This test is not standardized enough to put in the LSC standard m4
# tests repository

define([LSC_MPI_CHECK_EXTERN_C],[
AC_MSG_CHECKING(for extern "C" MPI types)

touch conftest.o
rm -f conftest.o
cat > conftest.C <<EOF
#include <mpi.h>

extern "C" {
  void op_foo(void *invec, void *inoutvec, int *len, 
	      MPI_Datatype *type);
}

int
main(int argc, char* argv[])
{ 
  MPI_User_function *f = op_foo;
  return 0; 
}
EOF
echo configure:__oline__: $CXX $CXXFLAGS -c conftest.C >&5
$CXX $CXXFLAGS -c conftest.C > conftest.out 2>&1
if test "$_"; then
    # If it didn't compile, automatically set it bad
    badness=1
else
    # If it did compile, check for warnings in the output
    badness="`grep -i warn conftest.out`"
fi
# Double check for if it didn't compile
if test ! -f conftest.o -a ! -f conftest.lo; then
    badness=1
fi
# Send the output to config.log as well so that we have a record of
# what happened
cat conftest.out >&5
# Now take action
if test "$badness" = ""; then
    OOMPI_MPI_EXTERN_C=1
    AC_MSG_RESULT(needed)
else
    OOMPI_MPI_EXTERN_C=0
    AC_MSG_RESULT(not needed)
fi
AC_DEFINE_UNQUOTED(OOMPI_MPI_EXTERN_C, $OOMPI_MPI_EXTERN_C,
    [Whether we need extern "C" for the MPI_User_function type or not])
rm -f conftest.*
])dnl
