dnl -*- shell-script -*-
dnl
dnl Copyright (c) 2002-2003 Indiana University.  All rights reserved.
dnl Copyright (c) 1996, 1997, 1998, 2000 University of Notre Dame.
dnl                         All rights reserved.
dnl 
dnl This file is part of the OOMPI software package.  For license
dnl information, see the LICENSE file in the top level directory of the
dnl OOMPI source distribution.
dnl
dnl $Id: cxx_find_exception_flags.m4,v 1.5 2003/02/13 21:07:46 jsquyres Exp $
dnl

define([LSC_CXX_FIND_EXCEPTION_FLAGS],[
#
# Get the exception handling flags for the C++ compiler
#
# Sets LSC_CXX_EXCEPTION_CXXFLAGS and LSC_CXX_EXCEPTION_LDFLAGS as
# appropriate.
# Calls AC_SUBST on both
#

AC_ARG_WITH(exflags,
    AC_HELP_STRING([--with-exflags],
	           [Specify flags necessary to enable exceptions]),
	FORCE_EXFLAGS="$withval")

CXXFLAGS_SAVE="$CXXFLAGS"
AC_MSG_CHECKING([for compiler exception flags])
if test "$FORCE_EXFLAGS" != ""; then
    EXFLAGS="$FORCE_EXFLAGS"
elif test "$GXX" = "yes"; then
    CXXFLAGS="$CXXFLAGS -fexceptions"

    AC_LANG_SAVE
    AC_LANG_CPLUSPLUS
    AC_TRY_COMPILE(, [try { int i = 0; } catch(...) { int j = 2; }], HAPPY=1, HAPPY=0)

    if test "$HAPPY" = "1"; then
	EXFLAGS="-fexceptions";
    else
	CXXFLAGS="$CXXFLAGS_SAVE -fhandle-exceptions"
	AC_TRY_COMPILE(, [try { int i = 0; } catch(...) { int j = 2; }], HAPPY=1, HAPPY=0)
	if test "$HAPPY" = "1"; then
	    EXFLAGS="-fhandle-exceptions";
	fi
    fi
    AC_LANG_RESTORE
elif test "`basename $CXX`" = "KCC" -o "`basename $LAMHCP`" = "KCC"; then
    EXFLAGS="--exceptions"
fi
CXXFLAGS="$CXXFLAGS_SAVE"

LSC_CXX_EXCEPTION_CXXFLAGS="$EXFLAGS"
LSC_CXX_EXCEPTION_LDFLAGS="$EXFLAGS"
if test "$EXFLAGS" = ""; then
    AC_MSG_RESULT([none necessary])
else
    AC_MSG_RESULT([$EXFLAGS])
fi
AC_SUBST(LSC_CXX_EXCEPTION_CXXFLAGS)
AC_SUBST(LSC_CXX_EXCEPTION_LDFLAGS)])dnl

