dnl -*- shell-script -*-
dnl
dnl Copyright (c) 2002-2003 Indiana University.  All rights reserved.
dnl Copyright (c) 1996, 1997, 1998, 2000 University of Notre Dame.
dnl                         All rights reserved.
dnl 
dnl This file is part of the OOMPI software package.  For license
dnl information, see the LICENSE file in the top level directory of the
dnl OOMPI source distribution.
dnl
dnl $Id: mpi_check_err_pending.m4,v 1.3 2003/02/13 21:07:46 jsquyres Exp $
dnl

define([LSC_MPI_CHECK_ERR_PENDING],[
#
# At least one MPI implementation has(had) this problem
# (no names mentioned...)
#
# Sets LSC_MPI_ERR_PENDING to 1 if MPI_PENDING, 0 if MPI_ERR_PENDING
# Defines LSC_MPI_ERR_PENDING as same
#

AC_MSG_CHECKING([whether to use MPI(_ERR)_PENDING])
AC_TRY_COMPILE([#include <mpi.h>]
, int yow=MPI_PENDING;, use_pending=yes, use_pending=no)
if test "$use_pending" = "yes"; then
    LSC_MPI_ERR_PENDING=1
    AC_MSG_RESULT([MPI_PENDING])
else
    LSC_MPI_ERR_PENDING=0
    AC_MSG_RESULT([MPI_ERR_PENDING])
fi
AC_DEFINE_UNQUOTED(LSC_MPI_ERR_PENDING, $LSC_MPI_ERR_PENDING,
    [Whether we have MPI_PENDING or MPI_ERR_PENDING])])dnl

